/**
 * Inheritence Examples
 */

abstract class Animal {
    public abstract String sound();
    private String a = "animal"+Math.random();
    protected String b = "haha";
    public String getA(){
        return a;
    }
}
class Dog extends Animal {
    public String sound(){
        return "bark";
    }
    public String toString(){
        return "dog: "+sound();
    }
}
class Cat extends Animal {
    public String sound(){
        return "meow";
    }
}
public class Inh {
    public static void main(String[] args) throws Throwable {
        Dog d = new Dog();
        Cat c = new Cat();
        System.out.println("d: "+d.sound());
        System.out.println("c: "+c.sound());

        Animal a = d;
        System.out.println("a: "+a.sound());
        
        Animal b = new Dog();
        System.out.println("b: "+b.sound());

        Dog e = (Dog) b;
        System.out.println("e: "+e.sound());
        
    }
}



